Index: library/bdm/stat/exp_family.h
===================================================================
--- library/bdm/stat/exp_family.h (revision 487)
+++ library/bdm/stat/exp_family.h (revision 488)
@@ -1204,15 +1171,15 @@
 // };
 
-	template<class sq_T>
-	vec enorm<sq_T>::sample() const
-	{
-		vec x ( dim );
+template<class sq_T>
+vec enorm<sq_T>::sample() const
+{
+	vec x (dim);
 #pragma omp critical
-		NorRNG.sample_vector ( dim,x );
-		vec smp = R.sqrt_mult ( x );
-
-		smp += mu;
-		return smp;
-	};
+	NorRNG.sample_vector (dim, x);
+	vec smp = R.sqrt_mult (x);
+
+	smp += mu;
+	return smp;
+};
 
 // template<class sq_T>
@@ -1224,19 +1191,19 @@
 // };
 
-	template<class sq_T>
-	double enorm<sq_T>::evallog_nn ( const vec &val ) const
-	{
-		// 1.83787706640935 = log(2pi)
-		double tmp=-0.5* ( R.invqform ( mu-val ) );// - lognc();
-		return  tmp;
-	};
-
-	template<class sq_T>
-	inline double enorm<sq_T>::lognc () const
-	{
-		// 1.83787706640935 = log(2pi)
-		double tmp=0.5* ( R.cols() * 1.83787706640935 +R.logdet() );
-		return tmp;
-	};
+template<class sq_T>
+double enorm<sq_T>::evallog_nn (const vec &val) const
+{
+	// 1.83787706640935 = log(2pi)
+	double tmp = -0.5 * (R.invqform (mu - val));// - lognc();
+	return  tmp;
+};
+
+template<class sq_T>
+inline double enorm<sq_T>::lognc () const
+{
+	// 1.83787706640935 = log(2pi)
+	double tmp = 0.5 * (R.cols() * 1.83787706640935 + R.logdet());
+	return tmp;
+};
 
 
@@ -1267,67 +1234,67 @@
 
 
-	template<class sq_T>
-	enorm<sq_T>* enorm<sq_T>::marginal ( const RV &rvn ) const
-	{
-		it_assert_debug ( isnamed(), "rv description is not assigned" );
-		ivec irvn = rvn.dataind ( rv );
-
-		sq_T Rn ( R,irvn ); //select rows and columns of R
-
-		enorm<sq_T>* tmp = new enorm<sq_T>;
-		tmp->set_rv ( rvn );
-		tmp->set_parameters ( mu ( irvn ), Rn );
-		return tmp;
-	}
-
-	template<class sq_T>
-	mpdf* enorm<sq_T>::condition ( const RV &rvn ) const
-	{
-
-		it_assert_debug ( isnamed(),"rvs are not assigned" );
-
-		RV rvc = rv.subt ( rvn );
-		it_assert_debug ( ( rvc._dsize() +rvn._dsize() ==rv._dsize() ),"wrong rvn" );
-		//Permutation vector of the new R
-		ivec irvn = rvn.dataind ( rv );
-		ivec irvc = rvc.dataind ( rv );
-		ivec perm=concat ( irvn , irvc );
-		sq_T Rn ( R,perm );
-
-		//fixme - could this be done in general for all sq_T?
-		mat S=Rn.to_mat();
-		//fixme
-		int n=rvn._dsize()-1;
-		int end=R.rows()-1;
-		mat S11 = S.get ( 0,n, 0, n );
-		mat S12 = S.get ( 0, n , rvn._dsize(), end );
-		mat S22 = S.get ( rvn._dsize(), end, rvn._dsize(), end );
-
-		vec mu1 = mu ( irvn );
-		vec mu2 = mu ( irvc );
-		mat A=S12*inv ( S22 );
-		sq_T R_n ( S11 - A *S12.T() );
-
-		mlnorm<sq_T>* tmp=new mlnorm<sq_T> ( );
-		tmp->set_rv ( rvn ); tmp->set_rvc ( rvc );
-		tmp->set_parameters ( A,mu1-A*mu2,R_n );
-		return tmp;
-	}
-
-	////
-	///////
-	template<class sq_T>				
-			void mgnorm<sq_T >::set_parameters ( fnc* g0, const sq_T &R0 ) {g=g0; this->iepdf.set_parameters ( zeros ( g->dimension() ), R0 );}
-	template<class sq_T>				
-			void mgnorm<sq_T >::condition ( const vec &cond ) {this->iepdf._mu()=g->eval ( cond );};
-
-	template<class sq_T>
-	std::ostream &operator<< ( std::ostream &os,  mlnorm<sq_T> &ml )
-	{
-		os << "A:"<< ml.A<<endl;
-		os << "mu:"<< ml.mu_const<<endl;
-		os << "R:" << ml.iepdf->_R().to_mat() <<endl;
-		return os;
-	};
+template<class sq_T>
+enorm<sq_T>* enorm<sq_T>::marginal (const RV &rvn) const
+{
+	it_assert_debug (isnamed(), "rv description is not assigned");
+	ivec irvn = rvn.dataind (rv);
+
+	sq_T Rn (R, irvn);  //select rows and columns of R
+
+	enorm<sq_T>* tmp = new enorm<sq_T>;
+	tmp->set_rv (rvn);
+	tmp->set_parameters (mu (irvn), Rn);
+	return tmp;
+}
+
+template<class sq_T>
+mpdf* enorm<sq_T>::condition (const RV &rvn) const
+{
+
+	it_assert_debug (isnamed(), "rvs are not assigned");
+
+	RV rvc = rv.subt (rvn);
+	it_assert_debug ( (rvc._dsize() + rvn._dsize() == rv._dsize()), "wrong rvn");
+	//Permutation vector of the new R
+	ivec irvn = rvn.dataind (rv);
+	ivec irvc = rvc.dataind (rv);
+	ivec perm = concat (irvn , irvc);
+	sq_T Rn (R, perm);
+
+	//fixme - could this be done in general for all sq_T?
+	mat S = Rn.to_mat();
+	//fixme
+	int n = rvn._dsize() - 1;
+	int end = R.rows() - 1;
+	mat S11 = S.get (0, n, 0, n);
+	mat S12 = S.get (0, n , rvn._dsize(), end);
+	mat S22 = S.get (rvn._dsize(), end, rvn._dsize(), end);
+
+	vec mu1 = mu (irvn);
+	vec mu2 = mu (irvc);
+	mat A = S12 * inv (S22);
+	sq_T R_n (S11 - A *S12.T());
+
+	mlnorm<sq_T>* tmp = new mlnorm<sq_T> ();
+	tmp->set_rv (rvn); tmp->set_rvc (rvc);
+	tmp->set_parameters (A, mu1 - A*mu2, R_n);
+	return tmp;
+}
+
+////
+///////
+template<class sq_T>
+void mgnorm<sq_T >::set_parameters (fnc* g0, const sq_T &R0) {g = g0; this->iepdf.set_parameters (zeros (g->dimension()), R0);}
+template<class sq_T>
+void mgnorm<sq_T >::condition (const vec &cond) {this->iepdf._mu() = g->eval (cond);};
+
+template<class sq_T>
+std::ostream &operator<< (std::ostream &os,  mlnorm<sq_T> &ml)
+{
+	os << "A:" << ml.A << endl;
+	os << "mu:" << ml.mu_const << endl;
+	os << "R:" << ml._R() << endl;
+	return os;
+};
 
 }
Index: library/bdm/stat/merger.h
===================================================================
--- library/bdm/stat/merger.h (revision 477)
+++ library/bdm/stat/merger.h (revision 488)
@@ -178,5 +178,5 @@
 	//! Set support points from a pdf by drawing N samples
 	void set_support ( const epdf &overall, int N ) {
-		eSmp.set_statistics ( &overall, N );
+		eSmp.set_statistics ( overall, N );
 		Npoints = N;
 	}
Index: library/bdm/stat/emix.h
===================================================================
--- library/bdm/stat/emix.h (revision 487)
+++ library/bdm/stat/emix.h (revision 488)
@@ -472,38 +472,39 @@
 
 
-/*! \brief Mixture of mpdfs with constant weights, all mpdfs are of equal type
+/*! \brief Mixture of mpdfs with constant weights, all mpdfs are of equal RV and RVC
 
 */
-// class mmix : public mpdf {
-// protected:
-// 	//! Component (epdfs)
-// 	Array<mpdf*> Coms;
-// 
-// 	//!Internal epdf
-// 	emix iepdf;
-// 
-// public:
-// 	//!Default constructor
-// 	mmix() : iepdf ( ) {
-// 		set_ep ( iepdf );
-// 	}
-// 
-// 	//! Set weights \c w and components \c R
-// 	void set_parameters ( const vec &w, const Array<mpdf*> &Coms ) {
-// 		Array<epdf*> Eps ( Coms.length() );
-// 
-// 		for ( int i = 0; i < Coms.length(); i++ ) {
-// 			Eps ( i ) = Coms ( i )->e();
-// 		}
-// 
-// 		iepdf->set_parameters ( w, Eps );
-// 	}
-// 
-// 	void condition ( const vec &cond ) {
-// 		for ( int i = 0; i < Coms.length(); i++ ) {
-// 			Coms ( i )->condition ( cond );
-// 		}
-// 	};
-// };
+class mmix : public mpdf {
+protected:
+	//! Component (mpdfs)
+	Array<shared_ptr<mpdf> > Coms;
+	//!weights of the components
+	vec w;
+	//! dummy epdfs
+	epdf dummy_epdf;
+public:
+	//!Default constructor
+	mmix() : Coms(0), dummy_epdf() { set_ep(dummy_epdf);	}
+
+	//! Set weights \c w and components \c R
+	void set_parameters ( const vec &w0, const Array<shared_ptr<mpdf> > &Coms0 ) {
+		//!\TODO check if all components are OK
+		Coms = Coms0;
+		w=w0;	
+		
+		set_rv(Coms(0)->_rv());
+		set_rvc(Coms(0)->_rvc());
+	}
+	double evallogcond (const vec &dt, const vec &cond) {
+		double ll=0.0;
+		for (int i=0;i<Coms.length();i++){
+			ll+=Coms(i)->evallogcond(dt,cond);
+		}
+		return ll;
+	}
+
+	vec samplecond (const vec &cond);
+
+};
 
 }
Index: library/bdm/stat/exp_family.cpp
===================================================================
--- library/bdm/stat/exp_family.cpp (revision 487)
+++ library/bdm/stat/exp_family.cpp (revision 488)
@@ -305,15 +305,14 @@
 }
 
-void eEmp::set_statistics ( const vec &w0, const epdf* epdf0 ) {
+void eEmp::set_statistics ( const vec &w0, const epdf &epdf0 ) {
 	//it_assert_debug(rv==epdf0->rv(),"Wrong epdf0");
-	dim = epdf0->dimension();
+	dim = epdf0.dimension();
 	w = w0;
 	w /= sum ( w0 );//renormalize
 	n = w.length();
 	samples.set_size ( n );
-	dim = epdf0->dimension();
 
 	for ( int i = 0; i < n; i++ ) {
-		samples ( i ) = epdf0->sample();
+		samples ( i ) = epdf0.sample();
 	}
 }
Index: library/tests/test_particle.cpp
===================================================================
--- library/tests/test_particle.cpp (revision 477)
+++ library/tests/test_particle.cpp (revision 488)
@@ -25,5 +25,5 @@
 	euni eun;
 	eun.set_parameters ( "0", "1" );
-	emp.set_statistics ( ones ( 10 ), &eun );
+	emp.set_statistics ( ones ( 10 ), eun );
 	vec &v = emp._w();
 	Array<vec> &S = emp._samples();
Index: library/tests/test_kalman_QR.cpp
===================================================================
--- library/tests/test_kalman_QR.cpp (revision 477)
+++ library/tests/test_kalman_QR.cpp (revision 488)
@@ -69,5 +69,6 @@
 	KF_QR.set_parameters ( &evolQR, &evolQR, 100 );
 	evolQR.condition ( "1 1 1" );
-	KF_QR.set_statistics ( evolQR.e(), &KF );
+	egamma kfinit=egamma("10 10 10","1 1 1");
+	KF_QR.set_statistics ( egamma("10 10 10","1 1 1"), &KF );
 	const epdf& mpost = KF_QR.posterior();
 	const epdf& mposttr = KFtr.posterior();
Index: library/tests/testResample.cpp
===================================================================
--- library/tests/testResample.cpp (revision 477)
+++ library/tests/testResample.cpp (revision 488)
@@ -25,5 +25,5 @@
 	euni eun;
 	eun.set_parameters ( "0", "1" );
-	emp.set_statistics ( ones ( 10 ), &eun );
+	emp.set_statistics ( ones ( 10 ), eun );
 	vec &v = emp._w();
 	Array<vec> &S = emp._samples();
Index: library/tests/testSmp.cpp
===================================================================
--- library/tests/testSmp.cpp (revision 477)
+++ library/tests/testSmp.cpp (revision 488)
@@ -86,5 +86,5 @@
 	cout << "======= MMix ======== " << endl;
 	mmix mMix;
-	Array<mpdf*> mComs ( 2 );
+	Array<shared_ptr<mpdf> > mComs ( 2 );
 	mComs ( 0 ) = &mG;
 	eN.set_mu ( vec_2 ( 0.0, 0.0 ) );
@@ -94,5 +94,5 @@
 
 	Smp = mMix.samplecond_m ( mu0, N );
-	disp ( mMix.e()->mean(), zeros ( 2 ), Smp );
+	disp ( 0.5*eN.mean()+0.4*eG.mean(), zeros ( 2 ), Smp );
 
 	cout << "======= EProd ======== " << endl;
